import ddf.minim.*;
import ddf.minim.signals.*;
import ddf.minim.analysis.*;
import ddf.minim.effects.*;

import hypermedia.video.*;

import processing.video.*;

import TUIO.*;
import java.util.*;

//Capture myCapture;
OpenCV opencv;

Minim minim;
AudioPlayer s7;

Movie m4;
Movie m8;
Movie m17;
Movie m19;
Movie m20;
Movie m21;
Movie m23;
Movie m24;
Movie m25;

PImage p0;
PImage p1;
PImage pp2;
PImage p3;
PImage p5;
PImage p6;
PImage p9;
PImage p10;
PImage p11;
PImage p12;
PImage p13;
PImage p14;
PImage p15;
PImage p16;
PImage p18;
PImage p22;
PImage p26;
PImage p27;
PImage p28;
PImage p29;

int W = 640;
int H = 480;

float wmax;
float hmax;

Hashtable playing;


TuioProcessing tuioClient;

void setup(){

  size(W,H);
  
  wmax = W/2;
  hmax = H/2;
  
  frameRate(30);

  playing = new Hashtable();

  minim = new Minim(this);

  tuioClient = new TuioProcessing(this);

  initContent();
  
  opencv = new OpenCV( this );
    opencv.capture( width, height );
  
  //myCapture = new Capture(this, width, height, 30);

}


void captureEvent(Capture myCapture) {
  //myCapture.read();
}







void draw(){

  //image(myCapture, 0, 0);
  
  opencv.read();
  image( opencv.image(), 0, 0 );

  Vector tuioObjectList = tuioClient.getTuioObjects();
  for (int i=0;i<tuioObjectList.size();i++) {
     TuioObject tobj = (TuioObject)tuioObjectList.elementAt(i);
     
     
     
     String sid = "" + tobj.getSymbolID();
  
    if(playing.get( sid )==null ){
      playing.put(sid,"N");
    }
  
    String pstate = (String) playing.get( sid );
  
    if(pstate.equals("S")){
      
      float ww;
      float hh;
      float p = 1;
      float p2 = 1;
      
      if( sid.equals("0") ){
        
        ww = p0.width;
        hh = p0.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
      
        image(p0,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
      } else if( sid.equals("1") ){
        
        ww = p1.width;
        hh = p1.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p1,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      
      } else if( sid.equals("2") ){
        ww = pp2.width;
        hh = pp2.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        image(pp2,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("3") ){
        
        ww = p3.width;
        hh = p3.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p3,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("4") ){
        
        ww = m4.width;
        hh = m4.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        
        image(m4,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("5") ){
        
        ww = p5.width;
        hh = p5.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p5,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("6") ){
        
        
        ww = p6.width;
        hh = p6.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p6,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
        
        
      } else if( sid.equals("7") ){
      
      } else if( sid.equals("8") ){
        
        ww = m8.width;
        hh = m8.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m8,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("9") ){
        
        
        
        ww = p9.width;
        hh = p9.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p9,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
        
        
      
      } else if( sid.equals("10") ){
        
        ww = p10.width;
        hh = p10.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p10,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("11") ){
        
        ww = p11.width;
        hh = p11.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p11,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("12") ){
        
        ww = p12.width;
        hh = p12.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p12,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("13") ){
        
        ww = p13.width;
        hh = p13.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p13,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("14") ){
        
        ww = p14.width;
        hh = p14.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p14,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("15") ){
        
        ww = p15.width;
        hh = p15.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p15,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("16") ){
        
        ww = p16.width;
        hh = p16.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        image(p16,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("17") ){
        
        ww = m17.width;
        hh = m17.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m17,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("18") ){
        
        
        ww = p18.width;
        hh = p18.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p18,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
        
      
      } else if( sid.equals("19") ){
      
        
        ww = m19.width;
        hh = m19.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m19,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
        
        
      } else if( sid.equals("20") ){
        
        ww = m20.width;
        hh = m20.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m20,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("21") ){
        
        ww = m21.width;
        hh = m21.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m21,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("22") ){
        
        
        ww = p22.width;
        hh = p22.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p22,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
        
        
      
      } else if( sid.equals("23") ){
        
        ww = m23.width;
        hh = m23.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m23,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("24") ){
        
        ww = m24.width;
        hh = m24.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m24,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("25") ){
        
        ww = m25.width;
        hh = m25.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(m25,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("26") ){
        
        
        ww = p26.width;
        hh = p26.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p26,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
      
      } else if( sid.equals("27") ){
        
        
        
        ww = p27.width;
        hh = p27.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p27,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
        
        
      
      } else if( sid.equals("28") ){
        
        ww = p28.width;
        hh = p28.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p28,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      } else if( sid.equals("29") ){
        
        ww = p29.width;
        hh = p29.height;
        if(ww>wmax){
          p = ww/wmax;
        }  
        
        if(hh>hmax){
          p2 = hh/hmax;
          if(p2>p){
            p = p2;
          }
        }
        
        ww = ww/p;
        hh = hh/p;
        
        image(p29,tobj.getScreenX(width)-ww/2,tobj.getScreenY(height)-hh/2,ww,hh);
      }
      
    }

  }
  



}








void addTuioObject(TuioObject tobj){
  
  String sid = "" + tobj.getSymbolID();
  
  if(playing.get( sid )==null ){
    playing.put(sid,"N");
  }
  
  String pstate = (String) playing.get( sid );
 
 if(pstate.equals("N")){
 
   playing.put(sid,"S");
   
   if(sid.equals("0")){
     
   } else if(sid.equals("1")){
     
   } else if(sid.equals("2")){
     
   } else if(sid.equals("3")){
     
   } else if(sid.equals("4")){
     m4.speed(1);
   } else if(sid.equals("5")){
     
   } else if(sid.equals("6")){
     
   } else if(sid.equals("7")){
     
     if(!s7.isPlaying()){
       s7.play();
     }   
     
   } else if(sid.equals("8")){
     m8.speed(1);
   } else if(sid.equals("9")){
   
   } else if(sid.equals("10")){
     
   } else if(sid.equals("11")){
     
   } else if(sid.equals("12")){
     
   } else if(sid.equals("13")){
     
   } else if(sid.equals("14")){
     
   } else if(sid.equals("15")){
     
   } else if(sid.equals("16")){
     
   } else if(sid.equals("17")){
     m17.speed(1);
   } else if(sid.equals("18")){
     
   } else if(sid.equals("19")){
     m19.speed(1);
   } else if(sid.equals("20")){
     m20.speed(1);
   } else if(sid.equals("21")){
     m21.speed(1);
   } else if(sid.equals("22")){
     
   } else if(sid.equals("23")){
     m23.speed(1);
   } else if(sid.equals("24")){
     m24.speed(1);
   } else if(sid.equals("25")){
     m25.speed(1);
   } else if(sid.equals("26")){
   
   } else if(sid.equals("27")){
   
   } else if(sid.equals("28")){
     
   } else if(sid.equals("29")){
     
   } 
   
   
 } 
  
}











void removeTuioObject(TuioObject tobj){

    String sid = "" + tobj.getSymbolID();
  
  if(playing.get( sid )==null ){
    playing.put(sid,"N");
  }
  
  String pstate = (String) playing.get( sid );
 
 if(pstate.equals("S")){
 
   playing.put(sid,"N");
   
   if(sid.equals("0")){
     
   } else if(sid.equals("1")){
     
   } else if(sid.equals("2")){
     
   } else if(sid.equals("3")){
     
   } else if(sid.equals("4")){
     m4.speed(0);
   } else if(sid.equals("5")){
     
   } else if(sid.equals("6")){
     
   } else if(sid.equals("7")){
     s7.pause();
     
   } else if(sid.equals("8")){
     m8.speed(0);
   } else if(sid.equals("9")){
   
   } else if(sid.equals("10")){
     
   } else if(sid.equals("11")){
     
   } else if(sid.equals("12")){
     
   } else if(sid.equals("13")){
     
   } else if(sid.equals("14")){
     
   } else if(sid.equals("15")){
     
   } else if(sid.equals("16")){
     
   } else if(sid.equals("17")){
     m17.speed(0);
   } else if(sid.equals("18")){
     
   } else if(sid.equals("19")){
     m19.speed(0);
   } else if(sid.equals("20")){
     m20.speed(0);
   } else if(sid.equals("21")){
     m21.speed(0);
   } else if(sid.equals("22")){
     
   } else if(sid.equals("23")){
     m23.speed(0);
   } else if(sid.equals("24")){
     m24.speed(0);
   } else if(sid.equals("25")){
     m25.speed(0);
   } else if(sid.equals("26")){
   
   } else if(sid.equals("27")){
   
   } else if(sid.equals("28")){
     
   } else if(sid.equals("29")){
     
   } 
   
   
 } 


}


void updateTuioObject(TuioObject tobj){
}

void refresh(TuioTime bundleTime){
}






void stop(){
  
  opencv.stop();
  s7.close();
  minim.stop();
    super.stop();

}














void addTuioCursor(TuioCursor tcur){}
void removeTuioCursor(TuioCursor tcur) {}
void updateTuioCursor(TuioCursor tcur) {}







void initContent(){



m4= new Movie(this, "4.mov",30);
m4.loop();
m4.speed(0);


m8= new Movie(this, "8.mov",30);
m8.loop();
m8.speed(0);


m17= new Movie(this, "17.mov",30);
m17.loop();
m17.speed(0);

m19= new Movie(this, "19.mov",30);
m19.loop();
m19.speed(0);


m20= new Movie(this, "20.mov",30);
m20.loop();
m20.speed(0);

m21= new Movie(this, "21.mov",30);
m21.loop();
m21.speed(0);

m23= new Movie(this, "23.mov",30);
m23.loop();
m23.speed(0);

m24= new Movie(this, "24.mov",30);
m24.loop();
m24.speed(0);

m25= new Movie(this, "25.mov",30);
m25.loop();
m25.speed(0);


p0 = loadImage("p0.png");
p1 = loadImage("p1.png");
pp2 = loadImage("p2.png");
p3 = loadImage("p3.png");
p5 = loadImage("p5.png");
p10 = loadImage("p10.png");
p11 = loadImage("p11.png");
p12 = loadImage("p12.png");
p13 = loadImage("p13.png");
p14 = loadImage("p14.png");
p15 = loadImage("p15.png");
p16 = loadImage("p16.png");
p28 = loadImage("p28.png");
p29 = loadImage("p29.png");

p6 = loadImage("6.png");
p9 = loadImage("9.jpg");
p18 = loadImage("18.png");
p22 = loadImage("22.png");
p26 = loadImage("26.png");
p27 = loadImage("27.png");

s7 = minim.loadFile("7.wav", 2048);
//s7.loop();
//s7.setVolume(0);
}








void movieEvent(Movie m) {
  m.read();
}

